#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <fcntl.h>

#define SHM_FILE "/pmarks-webcam"
#define SHM_MODE 0600
#define MAX_FRAME 40000
#define BUF_COUNT 2

#define MAX_VIEWERS 64

#define MAX_IMG 5000
//#define LOADING_GIF "loading.png"
#define OFFLINE_IMG "offline.png"

#define TIMEOUT 4

#define SERVER_ADDR "128.211.194.173"
#define SERVER_PORT 55581

struct shm_data {
	char deadspace[MAX_VIEWERS];  // Each viewer locks one byte here to
	                              // mark their presence
	int sync;    // Changed after each frame update
	int index;   // Index of the latest complete frame
	struct {
		int len;
		char frame[MAX_FRAME];
	} buf[BUF_COUNT];
};

int shm_open(const char *name, int oflag, mode_t mode);

extern struct flock index_lk, buf_lk[BUF_COUNT];

void make_lock(struct flock *fl, off_t base, size_t len);
void init_locks(void);
void lock_wait(int fd, short type, struct flock *fl);
int init_shm(struct shm_data **shm, int prot);
int initUDP(struct sockaddr_in *to_addr);
void sendUDP(int fd, char *data, int len, struct sockaddr_in *to);
void readall(void *buf, size_t count);
void writeall(void *buf, size_t count);
